/*
Test
====
-narrower window

*/

if(!com) var com={};
if(!com.savard) com.savard={};
if(!com.savard.gmailadblocker) com.savard.gmailadblocker=null;

com.savard.gmailadblocker = {
	DONATE_LINK_NAME: "Webmail Ad Blocker",
	DONATE_LINK_TOOLTIP: "Please donate to the author of this addon by clicking here!",
	DONATE_LINK_URL: "javascript:;",
	prefManager: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.gmailadblocker."),
	mainGmailFrame: null,
	mainYahooDoc: null,
	replaceCSSValue: function(node, attrName, newAttrValue) {
		var attrValue = node.css(attrName);
		var style = node.attr("style");
		var oldAttrPair = attrName + ": " + attrValue + " !important";
		if (style.indexOf(oldAttrPair) == -1) {
			oldAttrPair = attrName + ": " + attrValue + " ! important";
			if (style.indexOf(oldAttrPair) == -1) {
				oldAttrPair = attrName + ": " + attrValue;
			}
		}
		if (style.indexOf(oldAttrPair) != -1) {
			node.attr("style", style.replace(oldAttrPair, attrName + ": " + newAttrValue + " !important") );
		} else {
			node.attr("style", style += "; " + attrName + ": " + newAttrValue + " !important");
		}
	},
	getNode: function(doc, xpath) {
		var node = doc.evaluate(xpath, doc, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
		if (node && node.snapshotLength == 1) {
			return node.snapshotItem(0);
		}
	},
	hideNode: function(doc, xpath) {
		var obj = this.getNode(doc, xpath);
		if (obj) {
			obj.style.display = 'none';
			return true;
		}
		return false;
	},
	addDonationClickedEvent: function(donationNode, doc) {
		donationNode.addEventListener('click', function(event) {							
			var amount = prompt("Webmail Ad Blocker is active! Remove this link and contribute by entering any amount to donate: (USD)");
			if (amount) {
				if (parseFloat(amount) < 1) {
					alert("You must donate alteast $1");
				} else {
					window.open("https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=jasonsavard%40gmail%2ecom&no_note=1&no_shipping=1&item_name=Webmail%20Ad%20Blocker&currency_code=USD&amount=" + amount, '_blank');
					com.savard.gmailadblocker.prefManager.setBoolPref("donationClicked", true);
					com.savard.gmailadblocker.prefManager.setBoolPref("donateLink", false);
					doc.defaultView.top.location.reload();
				}
			}
		}, false);
	},	
	displayDonateLink: function(doc, prefManager) {
		if (prefManager.getBoolPref("donateLink")) {

			/* old nav */
			/*
			var topRight = doc.getElementById("guser");
			if (topRight) {
				var linkNameIdx = topRight.innerHTML.indexOf(this.DONATE_LINK_NAME);
				var refNode = this.getNode(doc, "//div[@id='guser']/nobr/child::node()[1]");
				if (refNode && linkNameIdx == -1) {
					var sepNode = doc.createElement('span');
					var txt = doc.createTextNode(" | ");
					sepNode.appendChild(txt);
					var donationNode = doc.createElement('a');
					//donationNode.setAttribute("target", "_blank");
					donationNode.setAttribute("href", "javascript:;");
					//donationNode.setAttribute("onclick", "var val = prompt('abc');  {alert('good')} return false;");
					donationNode.setAttribute("class", "e");
					donationNode.setAttribute("title", this.DONATE_LINK_TOOLTIP);
					txt = doc.createTextNode(this.DONATE_LINK_NAME);
					donationNode.appendChild(txt);
					refNode.parentNode.insertBefore(donationNode, refNode);
					refNode.parentNode.insertBefore(sepNode, refNode);
					this.addDonationClickedEvent(donationNode, doc);

				}
			}
			*/

			// new top navigation
			var topRight = doc.getElementById("gbz");
			if (topRight) {
				var linkNameIdx = topRight.innerHTML.indexOf(this.DONATE_LINK_NAME);
				if (linkNameIdx == -1) {
					var liNode = doc.createElement('li');
					liNode.setAttribute("class", "gbt");
					//liNode.innerHTML = "<a class='gbzt' title=\"" + this.DONATE_LINK_TOOLTIP + "\" href='" + this.DONATE_LINK_URL + "'><span class='gbtb2'></span><span class='gbts'>" + this.DONATE_LINK_NAME + "</span></a>";

					var linkNode = doc.createElement('a');
					linkNode.setAttribute("class", "gbzt");
					linkNode.setAttribute("title", this.DONATE_LINK_TOOLTIP);
					linkNode.setAttribute("href", this.DONATE_LINK_URL);

					var linkSpan = doc.createElement("span");
					linkSpan.setAttribute("class", "gbtb2");
					var linkSpan2 = doc.createElement("span");
					linkSpan2.setAttribute("class", "gbts");
						var txt = doc.createTextNode(this.DONATE_LINK_NAME);
						linkSpan2.appendChild(txt);

					linkNode.appendChild(linkSpan);
					linkNode.appendChild(linkSpan2);
					liNode.appendChild(linkNode);

					var lastTopNav = doc.querySelector("#gbz .gbt:last-child");
					if (lastTopNav) {
						lastTopNav.parentNode.insertBefore(liNode, lastTopNav);
						this.addDonationClickedEvent(liNode);
					}
				}
			}
		}
	},
	removeTopRightLink: function(doc, xpath) {
		var node = this.getNode(doc, xpath);
		if (node) {
			var sepNode = node.parentNode.previousSibling;
			if (sepNode && sepNode.nodeValue && sepNode.nodeValue.indexOf("|") != -1) {
				sepNode.parentNode.removeChild(sepNode);
			}
			node.parentNode.removeChild(node);
		}
	},
	detectMenuItems: function(e) {
		var doc = this.mainGmailFrame.contentDocument;
		var prefManager = this.prefManager;
		var leftLinks = this.getNode(doc, "//a[contains(@href, '#inbox')]");
		if (leftLinks) {
			this.displayDonateLink(doc, prefManager);
			if (prefManager.getBoolPref("toplinks.reader") == false) {
				this.hideNode(doc, "//div[@id='gbar']//a[contains(@href, '/reader/')]");
			}
			if (prefManager.getBoolPref("toplinks.web") == false) {
				this.hideNode(doc, "//div[@id='gbar']//a[contains(@href, '/webhp')]");
			}
			if (prefManager.getBoolPref("toplinks.more") == false) {
				this.hideNode(doc, "//div[@id='gbar']//u[contains(text(), 'more')]//parent::a");
			}
			if (prefManager.getBoolPref("help") == false) {
				this.removeTopRightLink(doc, "//div[@id='guser']//a[contains(@href, '/support')]");
				this.removeTopRightLink(doc, "//div[@id='guser']//span[contains(@id, ':r4')]");
				this.removeTopRightLink(doc, "//div[@id='guser']//span[contains(text(), 'Help')]");
			}
			if (prefManager.getBoolPref("spamCount") == false) {
				var obj = this.getNode(doc, "//a[contains(@href, '#spam')]");
				if (obj) {
					obj.innerHTML = "Spam";
					obj.style.fontWeight = "normal";
				}
			}
			if (prefManager.getBoolPref("moreLabels") == false) {
				this.hideNode(doc, "//span[contains(@class, 'CJ')]//ancestor::div[1]");
			}
		} else {
			setTimeout(function () { com.savard.gmailadblocker.detectMenuItems(); }, 1000);
		}
	},
	onModified: function(e) {
		if (e.originalTarget instanceof HTMLBodyElement) {
			var doc = e.originalTarget.ownerDocument;			
			if (!this.getNode(doc, "//div[@id='main']//div[@id='toolbar']//span[contains(@id, 'webmailAdBlockerDonate')]")) {
				var toolbar = this.getNode(doc, "//div[contains(@id, 'pagetoolbar')]");
				if (toolbar) {
					var txt = doc.createTextNode("");
					var donationNode = doc.createElement('span');
					donationNode.setAttribute("id", "webmailAdBlockerDonate");
					donationNode.setAttribute("class", "btn left right");
					//donationNode.setAttribute("onclick", "window.open('" + this.DONATE_LINK_URL + "', '_blank');return false;");							
					donationNode.appendChild(txt);
					//donationNode.innerHTML = "<a href='javascript:;' title='" + this.DONATE_LINK_TOOLTIP + "'><span class='Label'>" + this.DONATE_LINK_NAME + "</span></a>";

					var linkNode = doc.createElement('a');
					linkNode.setAttribute("title", this.DONATE_LINK_TOOLTIP);
					linkNode.setAttribute("href", "javascript:;");

					var linkSpan = doc.createElement("span");
					linkSpan.setAttribute("class", "Label");
						var txt = doc.createTextNode(this.DONATE_LINK_NAME);
						linkSpan.appendChild(txt);
					linkNode.appendChild(linkSpan);
					donationNode.appendChild(linkNode);

					this.addDonationClickedEvent(donationNode, doc);
					toolbar.appendChild(donationNode, toolbar);
				}
			}
		}			
	},
	onPageLoad: function(e) {
		if (e.originalTarget instanceof HTMLDocument) {
			var doc = e.originalTarget;
			var prefManager = this.prefManager;
			var css = "@namespace url(http://www.w3.org/1999/xhtml); ";
			var addCSS = false;

			if (doc) {
				if (doc.location.href.match("google.com/calendar")) {
					addCSS = true;
					if (prefManager.getBoolPref("gcHighlightCurrentDay") == true) {
						css += " .st-dtitle-today {background:yellow !important} "; // highlight today header
						//css += " .st-bg-today {background:#FFFFCC !important} "; // highlight today square
					}
					if (prefManager.getBoolPref("gcHighlightWeekends") == true) {
						// Check that weekends are in calendar view (its user customizable)
						var node = doc.evaluate("//td[contains(@class, 'st-bg')]", doc, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
						if (node && node.snapshotLength > 25) { // no weekends will have 5*5=25 TDs w/ weekend will have 5*7=35 TDs
							var todayClass = "st-bg-today";
							var node = doc.evaluate("//td[contains(@class, '" + todayClass + "')]//parent::tr/td", doc, null,XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
							if (node) {
								var todayDayOfWeek;
								for (todayDayOfWeek=0; todayDayOfWeek<node.snapshotLength; todayDayOfWeek++) {
									if (node.snapshotItem(todayDayOfWeek).className && node.snapshotItem(todayDayOfWeek).className.indexOf(todayClass) != -1) {
										var dayOfWeek = new Date().getDay();
										if (dayOfWeek == todayDayOfWeek) {
											// Starts Sunday
											css += " .st-bg:first-child, .st-bg:last-child {background:#eee} ";
										} else if (dayOfWeek == todayDayOfWeek+1 || dayOfWeek == 0 && todayDayOfWeek == 6) {
											// Starts Monday
											css += " .st-bg:nth-last-child(-n+2) {background:#eee} ";
										} else {
											// Starts Saturday
											css += " .st-bg:first-child, .st-bg:nth-child(+2) {background:#eee} ";
										}
										break;
									}
								}
							}
						}
					}
					this.displayDonateLink(doc, prefManager);
				}

				if (doc.location.href.match("mail.google.")) {
					addCSS = true;
					var mainGmailFrame = doc.getElementById("canvas_frame");
					if (mainGmailFrame) {
						this.mainGmailFrame = mainGmailFrame;
						setTimeout(function () { com.savard.gmailadblocker.detectMenuItems(); }, 1000);
					}

					if (false /*prefManager.getBoolPref("gmail.actionLinks") == true*/) {
						/* Transform the message table to a block (used for relative positioning) */
						css += " table.iY { ";
						css += " 	display: block; ";
						css += " } ";

						/* Action Links Area (level 1) */
						css += " .iY .Bu:last-child .nH > .nH > .nH:first-child { ";
						css += " 	position: absolute !important; ";
						css += " 	top: 23px !important; ";
						css += " 	right: 0px!important; ";
						css += " 	font-size: 70% !important; ";
						css += " 	z-index:0 !important; ";
						css += " } ";

						/* Action Links Area (level 2) */
						css += " .iY .Bu:last-child .hj { ";
						css += " 	font-size: 100% !important; ";
						css += " 	margin: 0 auto !important; ";
						css += " 	float: right !important; ";
						css += " 	padding:0 !important; ";
						css += " 	position: relative; ";
						css += " } ";

						/* Action Link container */
						css += " .hk { ";
						css += " 	float: left !important; ";
						css += " 	padding:0 12px 0 0 !important; ";
						css += " } ";

						css += " .hk span {background:white} ";
					}

					// CHANGED "ads" to really mean whole right side				
					if (prefManager.getBoolPref("ads") == false) {
						// Old version
						css += " #fi #fic {margin-right:100px !important} ";
						css += " #fi #rh {margin-left:-115px !important;width:95px !important} ";
						css += " #fi .rh {display:none !important} ";

						// New version
						//css += " .iY .Bu:last-child > .nH {height: 0px !important;overflow: hidden !important;width: 1px !important} "; /* Ads Area - Jason: change from 0px to 1px cause right area was moving after loading */
						//css += " .iY .Bu:first-child + .Bu {display: none !important} "; /* Separator column */
						//css += " .iY {width: 100% !important} "; /* Message area */
						css += " body:not(.xE) div[role='main'] .Bu:not(:first-child) {display: none !important} "; /* Using div[role='main'] because i found out that .Bs and .Bu was used higher up in the node atleast with right side chat etc. */
					}

					// Hide ad below people widget
					css += " .Bs .Bu:last-child .oM {display:none !important} "; /* ads*/
					css += " .Bs .Bu:last-child .u8 {display:none !important} "; /* about these links */

					// Ad below email content (refer to ghazel@gmail.com for html or Mike Tirakis has reported it to me, a bit suspicious)
					css += " .z0DeRc {display:none !important} ";							
					// another ad below by Christian Szita
					css += " .nH.hx .nH.PS {display:none !important} ";

					// Ad below email content (refer to ghazel@gmail.com for html or Mike Tirakis has reported it to me, a bit suspicious)
					css += " iframe[src*='http://pagead2.googlesyndication.com'] {display:none !important} ";

					if (prefManager.getBoolPref("emailHighlighting")) {
						var normalViewPrefix = " .qRauBc:not(.Zheyfb) "; //.Zheyfb is present in vertical view
						var horizontalViewPrefix = " .nH.NUxIad.wV0Tif.KJpZkd:not(.nn) ";							
						var hoverCSS1 = " .zA.yO:hover {background: rgb(255,235,134) none repeat scroll 0 0 !important} ";
						var hoverCSS2 = " .zA.zE:hover {background: rgb(205,243,159) none repeat scroll 0 0 !important} ";
						
						css += normalViewPrefix + hoverCSS1;  
						css += normalViewPrefix + hoverCSS2;
						
						css += horizontalViewPrefix + hoverCSS1;
						css += horizontalViewPrefix + hoverCSS2;
					}
					if (prefManager.getBoolPref("chat") == false) {
						//css += " .nH.s {display:none} ";
						css += " .pS.s {display:none} ";
					}
					if (prefManager.getBoolPref("invites") == false) {
						//css += " .nH.pp.T0 .nH.pY .nH.r, .nH.pp.T0 .nH.pY .nH.pt {display:none} ";
						//css += " .nH.pp.T0:last-child {border-top:none !important} ";
						css += " .pS.pY {display:none !important} ";
					}
					if (prefManager.getBoolPref("selectAll") == false) {
						css += " .D.A1 .yV, .D.AY .yV {display:none} ";
					}
					if (prefManager.getBoolPref("messagesDragDrop") == false && prefManager.getBoolPref("checkBoxes") == false) {
						css += ".Cp .Ci {width:1px !important} ";
					} else if (prefManager.getBoolPref("messagesDragDrop") == false) {						
						css += " .Cl {background:none !important} ";
					} else if (prefManager.getBoolPref("checkBoxes") == false) {
						css += ".Cp .Ci {width:14px !important} ";
					}
					if (prefManager.getBoolPref("stars") == false) {
						css += " .y5 {width:2px !important} ";
						css += " .cf.zt .y4 {visibility:hidden;width:1px} ";
						css += " .lHQn1d {display:none} ";
					}
					if (prefManager.getBoolPref("searchButtons") == false) {
						css += ".bN.bM, .bN.bR {display:none} ";
					}
					if (prefManager.getBoolPref("actionButtons") == false) {
						css += " .Cq {display:none} ";
						css += " .Pl.J-J5-Ji {display:none !important} ";
						css += " .AP {display:none} "; // Refresh link
					}
					if (prefManager.getBoolPref("currentEmailIndicator") == false) {
						css += " .oZ-jd {visibility:hidden !important} ";
					}
					if (prefManager.getBoolPref("tips") == false) {
						css += " .nH.l2.ov .mn {display:none} ";
					}
					if (prefManager.getBoolPref("currentlyUsing") == false) {
						css += " .nH.l2.ov .md {display:none} ";
					}
					if (prefManager.getBoolPref("accountActivity") == false) {
						css += " .nH.l2.ov .l6 {display:none} ";
					}				
					if (prefManager.getBoolPref("gmailview") == false) {
						css += " .nH.l2.ov .mp {display:none} ";
					}
					if (prefManager.getBoolPref("copyright") == false) {
						css += " .nH.l2.ov .ma {display:none} ";
					}

				}

				if (doc.location.href.match("mail.live.")) {
					addCSS = true;
					if (prefManager.getBoolPref("hotmail.ads") == false) {						
						css += " iframe[id='dapIfM0'] {display:none !important} "; /* most ads:including ad below folders */

						css += " .Managed .WithSkyscraper #MainContent {right:0 !important} "; // with preview pane (default)
						css += " .Unmanaged .WithSkyscraper #MainContent {margin-right:0 !important} ";	// no preview pane

						css += " .Managed .WithRightRail #MainContent {right:0 !important} "; // with preview pane (default)
						css += " .Unmanaged .WithRightRail #MainContent {margin-right:0 !important} ";	// no preview pane

						css += " #SkyscraperContent {display:none !important} ";
						css += " #RadAd_Skyscraper {display:none !important} ";
						
						// outlook.com
						css += " #ManagedContentWrapper {padding-right:0 !important} ";
						css += " #RightRailContainer {display:none !important} ";

					}
					if (prefManager.getBoolPref("donateLink")) {
						var node = this.getNode(doc, "//li[contains(@class, 'ToolbarHelpLink ')]");
						if (node && node.parentNode.innerHTML.indexOf(this.DONATE_LINK_NAME) == -1) {
							var sepNode = doc.createElement('li');
							sepNode.setAttribute('class', 'ToolbarItem');
							var txt = doc.createTextNode("");
							sepNode.appendChild(txt);
							sepNode.innerHTML = "<span class='ToolbarPipe'>|</span>";

							var donationNode = doc.createElement('li');
							donationNode.setAttribute('class', 'ToolbarItem');
							var txt = doc.createTextNode("");
							donationNode.appendChild(txt);
							//donationNode.innerHTML = "<a id='webmail' href='" + this.DONATE_LINK_URL + "' title='" + this.DONATE_LINK_TOOLTIP + "'><span class='Label'>" + this.DONATE_LINK_NAME + "</span></a>";

							var linkNode = doc.createElement('a');
							linkNode.setAttribute("id", "webmail");
							linkNode.setAttribute("title", this.DONATE_LINK_TOOLTIP);
							linkNode.setAttribute("href", this.DONATE_LINK_URL);

							var linkSpan = doc.createElement("span");
							linkSpan.setAttribute("class", "Label");
								var txt = doc.createTextNode(this.DONATE_LINK_NAME);
								linkSpan.appendChild(txt);
							linkNode.appendChild(linkSpan);
							donationNode.appendChild(linkNode);

							this.addDonationClickedEvent(donationNode, doc);
							node.parentNode.insertBefore(sepNode, node);
							node.parentNode.insertBefore(donationNode, node);
						}
					}
				}

				if (doc.location.href.match("mail.yahoo.")) {
					addCSS = true;
					if (prefManager.getBoolPref("yahoo.ads") == false) {
						css += " *[class*='ad_slug'] {display:none !important} "; /* welcome page ad, empty inbox ad etc. */
						css += " div[id='MNW'] {display:none !important} "; /* Classic Yahoo:Ad above folder */
						css += " div[id='northbanner'] {display:none !important} "; /* Classic Yahoo:top banner */
						css += " iframe[src*='http://ad.'] {display:none !important} "; /* Classic Yahoo:top banner in calendar */
						
						// Beta version
						css += " #theAd {display:none !important} "; // right ad
						css += " #theMNWAd {display:none !important} "; // ad above inbox says... Sahil Best - sexy_sam28@ymail.com
						css += " #shellcontent {right:0 !important} "; // right ad							
						css += " #slot_LREC {display:none} "; // What's new landing page ad
						css += " #slot_REC {display:none !important} "; // left ad
						css += " #slot_MON {display:none} "; // Spam box ad

						// Beta version (with page by page view option)
						css += " .fullpage #main {margin-right:0 !important} ";

						if (prefManager.getBoolPref("donateLink")) {
							// Beta version
							doc.addEventListener("DOMSubtreeModified", function (e) { com.savard.gmailadblocker.onModified(e) }, true);
						}

						var foldersPane = doc.getElementById("foldersPane");
						if (foldersPane) {
							var contentWidth = doc.body.clientWidth - foldersPane.clientWidth - 10;
							//document.title = doc.body.clientWidth + "__" + foldersPane.clientWidth;
							//contentWidth = prompt(contentWidth, contentWidth);
							css += " #welcomeAdsContainer {display:none !important} "; /* On Home tab (welcome screen of yahoo mail */
							css += " #mainTabView {width:" + contentWidth + "px !important} ";
							css += " #mainTabView.withRightSpace {width:" + (contentWidth - 165) + "px !important} ";
								css += " #mainTablePane {width:100% !important} ";
								css += " .PagedTableView_container {width:100% !important} ";
							css += " div[id^='imcSession_'] {width:" + contentWidth + "px !important} "; /* Text/Chat message window */
							css += " #ym-skyhider {display:none !important} ";
							css += " #largePane {display:none !important} "; /* Right side wrapper */
							css += " #largePane.withRightSpace {display:block !important} "; /* Right side wrapper */
							css += " #largeFrame {display:none !important} "; /* Ad area */
							css += " #ym-skyscroller {display:none !important} "; /* Ad scrolling arrow */
						}
						
						if (!window.frameElement) {
							var iframes =  doc.getElementsByTagName("iframe");
							for (var a=0; a<iframes.length; a++) {
								iframes[a].addEventListener("load", function() {

									var foldersPane = doc.getElementById("foldersPane");
									if (foldersPane) {
										this.mainYahooDoc = doc;
									}
									var rightSideTray = null;
									if (this.mainYahooDoc) {
										rightSideTray = this.mainYahooDoc.getElementById("rightSideTray");
									}
									if (rightSideTray) {
										if (rightSideTray.style.display != "none") {
											if (this.mainYahooDoc.getElementById("largePane").className.indexOf("withRightSpace") == -1) {
												this.mainYahooDoc.getElementById("largePane").className += " withRightSpace";
											}
											if (this.mainYahooDoc.getElementById("mainTabView").className.indexOf("withRightSpace") == -1) {
												this.mainYahooDoc.getElementById("mainTabView").className += " withRightSpace";
											}
										} else {
											this.mainYahooDoc.getElementById("largePane").className = this.mainYahooDoc.getElementById("largePane").className.replace(/withRightSpace/g, "");
											this.mainYahooDoc.getElementById("mainTabView").className = this.mainYahooDoc.getElementById("mainTabView").className.replace(/withRightSpace/g, "");
										}
									}

									var node;
									if (prefManager.getBoolPref("donateLink")) {
										// Top right
										node = doc.getElementById("tabBarLinks");
										if (node) {
											if (node.innerHTML.indexOf(com.savard.gmailadblocker.DONATE_LINK_NAME) == -1) {
												var sepNode = doc.createElement('span');
												sepNode.setAttribute("class", "miniSeparator");
												var txt = doc.createTextNode(" | ");
												sepNode.appendChild(txt);													
												var donationNode = doc.createElement('a');
												donationNode.setAttribute("id", "webmailadblocker");
												//donationNode.setAttribute("target", "_blank");
												donationNode.setAttribute("href", com.savard.gmailadblocker.DONATE_LINK_URL);
												donationNode.setAttribute("class", "textLink");
												donationNode.setAttribute("hidefocus", "");
												donationNode.setAttribute("title", com.savard.gmailadblocker.DONATE_LINK_TOOLTIP);
												var txt = doc.createTextNode(com.savard.gmailadblocker.DONATE_LINK_NAME);
												donationNode.appendChild(txt);
												com.savard.gmailadblocker.addDonationClickedEvent(donationNode, doc);
												node.insertBefore(sepNode, node.firstChild); 
												node.insertBefore(donationNode, node.firstChild); 
											}
										}
										if (this.mainYahooDoc) {
											// Inbox view
											node = this.mainYahooDoc.getElementById("mainToolbar");
											if (node) {
												if (node.innerHTML.indexOf(com.savard.gmailadblocker.DONATE_LINK_NAME) == -1) {
													var donationNode = doc.createElement('span');
													donationNode.setAttribute("title", com.savard.gmailadblocker.DONATE_LINK_TOOLTIP);
													donationNode.setAttribute("style", "padding: 2px 10px 0px 15px");
													//donationNode.innerHTML = "<a href='" + com.savard.gmailadblocker.DONATE_LINK_URL + "'>" + com.savard.gmailadblocker.DONATE_LINK_NAME + "</a>";

													var linkNode = doc.createElement('a');
													linkNode.setAttribute("href", com.savard.gmailadblocker.DONATE_LINK_URL);
														var txt = doc.createTextNode(com.savard.gmailadblocker.DONATE_LINK_NAME);
														linkNode.appendChild(txt);
													donationNode.appendChild(linkNode);

													com.savard.gmailadblocker.addDonationClickedEvent(donationNode, doc);
													node.appendChild(donationNode, node);
												}
											}
											// In message view
											node = this.mainYahooDoc.getElementById("widget_item_2");
											if (node) {
												if (node.innerHTML.indexOf(com.savard.gmailadblocker.DONATE_LINK_NAME) == -1) {
													var donationNode = doc.createElement('span');
													donationNode.setAttribute("title", com.savard.gmailadblocker.DONATE_LINK_TOOLTIP);
													donationNode.setAttribute("style", "padding: 2px 10px 0px 15px");
													//donationNode.innerHTML = "<a href='" + com.savard.gmailadblocker.DONATE_LINK_URL + "'>" + com.savard.gmailadblocker.DONATE_LINK_NAME + "</a>";

													var linkNode = doc.createElement('a');
													linkNode.setAttribute("href", com.savard.gmailadblocker.DONATE_LINK_URL);
														var txt = doc.createTextNode(com.savard.gmailadblocker.DONATE_LINK_NAME);
														linkNode.appendChild(txt);
													donationNode.appendChild(linkNode);

													com.savard.gmailadblocker.addDonationClickedEvent(donationNode, doc);
													node.appendChild(donationNode, node);
												}
											}
										}
									}
								
								
								}, false);
							}
						}
					}
				}

				if (addCSS) {
					var heads = doc.getElementsByTagName("head");
					if (heads.length > 0) {
						var node = doc.createElement("style");
						node.type = "text/css";
						node.appendChild(doc.createTextNode(css));
						heads[0].appendChild(node);
					}
				}
			}
		}
	}
}

addEventListener("DOMContentLoaded", function (e) { com.savard.gmailadblocker.onPageLoad(e) }, true);

//com.savard.gmailadblocker.prefManager.setBoolPref("alreadyInstalled", false);

// 1345781732392 = Aug. 24th 2012 = the date i integrated this popup, i didn't want my previous users to get this popup, only new installers from that date and on
if (Date.now() > 1345781732392 && !com.savard.gmailadblocker.prefManager.getBoolPref("alreadyInstalled")) {
	var firstInstallPageTimer = setInterval(function() {
		try {
			gBrowser.addTab("http://jasonsavard.com?ref=WABInstall");
			com.savard.gmailadblocker.prefManager.setBoolPref("alreadyInstalled", true);
			clearInterval(firstInstallPageTimer);
		} catch (e) {
			//alert("errror: " + e);
		}
	}, 500);
}

/*
var win = Components.classes["@mozilla.org/appshell/window-mediator;1"]
		  .getService(Components.interfaces.nsIWindowMediator)
		  .getMostRecentWindow("navigator:browser");

if (win) {
	setTimeout(function() {
		win.gBrowser.loadOneTab(url, null, null, null, false, false);
	}, 10)
} else {
	window.open(url);
}
*/